<?php
require_once 'uniteimg.php';

/**
 * 認証画像クラス
 * $key = "test";
 * $authimg = new Authimg();
 * echo $authimg->getText($key);	// テキスト取得
 * $authimg->getImg($key);	// 画像取得
 */
class AuthImg
{
	// 桁数設定
	private $_len = 4;
	// コンストラクタ
	public function __construst()
	{
	}
	/**
	 * 画像イメージ取得
	 *
	 * @param	string	$key	キー
	 * @return	void
	 */
	public function getImg($key)
	{
		$num = $this->getText($key);
		$a = array();
		for ($i = 0; $i <= strlen($num)-1; $i++) {
			$a[$i] = dirname(__FILE__) . "/gif/{$num[$i]}.gif";
		}
		// 連結イメージの作成
		$image = uniteimg($a, 'h', 'c');
		if ($image) {
			// ヘッダ送信
			header('Content-Type: image/gif');
			// GIF画像として出力
			imagegif($image);
			// イメージを破棄
			imagedestroy($image);
			exit;
		} else {
			die("Can't unite images.");
		}
	}
	/**
	 * テキストデータ取得
	 *
	 * @param	string	$key	キー
	 * @return	int		$num	数字
	 */
	public function getText($key)
	{
		$num = "0123456789";
		$md5str = md5($key);
		for ($i=0; $i <= strlen($md5str)-1; $i++) {
			if (is_numeric($md5str[$i])) {
				$num = $this->_replaceArr($num, $num[$i], $num[$i+1]);
			}
		}
		$num = substr($num, 0, $this->_len);
		return $num;
	}
	/**
	 * 桁数設定
	 *
	 * @param	int		$value
	 * @return	void
	 */
	public function setLen($value)
	{
		if ($value > 10) return;
		$this->_len = $value;
	}
	/**
	 * 配列データの入れ替え
	 *
	 * @param	array	$arr	配列データ
	 * @param	int		$v1		入れ替え箇所1
	 * @param	int		$v2		入れ替え箇所2
	 * @return	array	$arr	配列データ
	 */
	private function _replaceArr($arr, $v1, $v2)
	{
		$temp = $arr[$v1];
		$arr[$v1] = $arr[$v2];
		$arr[$v2] = $temp;
		return $arr;
	}
}
?>